Bug 5662 - User get empty locale environment after "su -"
: User get empty locale environment after "su -"
Status: VERIFIED FIXED
Product: Desktop Bugs
Classification: ROSA Desktop
Component: Main Packages
: Fresh
: All Linux
: Normal normal
: ---
Assigned To: ROSA Linux Bugs
: ROSA Linux Bugs
:
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2015-05-29 19:53 MSD by a.lahin
Modified: 2015-06-09 14:56 MSD (History)
2 users (show)

See Also:
RPM Package: initscripts
ISO-related:
Bad POT generating:
Upstream:
vladimir.potapov: qa_verified+
denis.silakov: published+


Attachments
ss (169.62 KB, image/png)
2015-06-03 20:09 MSD, Vladimir Potapov
Details
ss2 (257.58 KB, image/png)
2015-06-04 12:23 MSD, Vladimir Potapov
Details
ss3 (242.81 KB, image/png)
2015-06-04 12:23 MSD, Vladimir Potapov
Details

Note You need to log in before you can comment on or make changes to this bug.
Description a.lahin 2015-05-29 19:53:24 MSD
User doesn't get system locale variables after "su -".

With initscripts-9.45-8:

>localectl
System Locale: LANG=ru_RU.UTF-8
               LANGUAGE=ru_RU.UTF-8:ru

>locale
LANG=ru_RU.UTF-8
LC_CTYPE="ru_RU.UTF-8"
LC_NUMERIC="ru_RU.UTF-8"
LC_TIME="ru_RU.UTF-8"
LC_COLLATE="ru_RU.UTF-8"
LC_MONETARY="ru_RU.UTF-8"
LC_MESSAGES="ru_RU.UTF-8"
LC_PAPER="ru_RU.UTF-8"
LC_NAME="ru_RU.UTF-8"
LC_ADDRESS="ru_RU.UTF-8"
LC_TELEPHONE="ru_RU.UTF-8"
LC_MEASUREMENT="ru_RU.UTF-8"
LC_IDENTIFICATION="ru_RU.UTF-8"
LC_ALL=

After:
>su
Пароль: 

>locale
LANG=ru_RU.UTF-8
LC_CTYPE="ru_RU.UTF-8"
LC_NUMERIC="ru_RU.UTF-8"
LC_TIME="ru_RU.UTF-8"
LC_COLLATE="ru_RU.UTF-8"
LC_MONETARY="ru_RU.UTF-8"
LC_MESSAGES="ru_RU.UTF-8"
LC_PAPER="ru_RU.UTF-8"
LC_NAME="ru_RU.UTF-8"
LC_ADDRESS="ru_RU.UTF-8"
LC_TELEPHONE="ru_RU.UTF-8"
LC_MEASUREMENT="ru_RU.UTF-8"
LC_IDENTIFICATION="ru_RU.UTF-8"
LC_ALL=



But after:
>su -
Пароль: 

>locale
LANG=
LC_CTYPE="POSIX"
LC_NUMERIC="POSIX"
LC_TIME="POSIX"
LC_COLLATE="POSIX"
LC_MONETARY="POSIX"
LC_MESSAGES="POSIX"
LC_PAPER="POSIX"
LC_NAME="POSIX"
LC_ADDRESS="POSIX"
LC_TELEPHONE="POSIX"
LC_MEASUREMENT="POSIX"
LC_IDENTIFICATION="POSIX"
LC_ALL=

Expected behaviour:
User after "su -" should get system locale environment if he has no personal one.
Comment 1 a.lahin 2015-05-29 19:55:11 MSD
Advisory: Fix empty locale environment

Build lists:
https://abf.io/build_lists/2505588
https://abf.io/build_lists/2505589
Comment 2 a.lahin 2015-06-01 13:49:41 MSD
Advisory: Fix empty locale environment (fixed)

Build lists:
https://abf.io/build_lists/2506510
https://abf.io/build_lists/2506511
Comment 3 Denis Silakov 2015-06-03 17:18:03 MSD
This update really fixed the issue with "su -" for me. Before update, I couldn't see Russian symbols in mc launched under "su -". After this update, everything is ok.
Comment 4 Vladimir Potapov 2015-06-03 20:09:53 MSD
Created attachment 4064 [details]
ss

а можно не пугать юзеров страшными диалогами? Там был какой-то ключ чтоб без запростов переписывало.
Comment 5 Denis Silakov 2015-06-03 21:33:41 MSD
Чтобы совсем не спрашивало, надо совсем убрать параметр "config" у соответсвующих файлов в пакете. Не уверен, что это хорошо. Если что-то сломается, то пользователи хотя бы будут знать, в какие файлы глянуть. Хотя может для нынешних пользователей десктопа это и не очень актуально...

В конце концов, тут же не предлагают что-то сделать или выбрать между непонятными действияи. Просто информаци к сведению.
Comment 6 Vladimir Potapov 2015-06-04 05:41:41 MSD
(In reply to comment #5)
> Чтобы совсем не спрашивало, надо совсем убрать параметр "config" у
> соответсвующих файлов в пакете. Не уверен, что это хорошо. Если что-то
> сломается, то пользователи хотя бы будут знать, в какие файлы глянуть. Хотя
> может для нынешних пользователей десктопа это и не очень актуально...
> 
> В конце концов, тут же не предлагают что-то сделать или выбрать между
> непонятными действияи. Просто информаци к сведению.
В том-то и дело что предлагают. Если тама на кнопку нажать, появляется диалог выбора. Т.к. файлы сейчас различаются комментариями насколько я понял, предлагаю все это убрать.
Comment 7 Denis Silakov 2015-06-04 09:55:32 MSD
Посмотрел. По сравнению с последней опубликованной версией (9.45-8) эти конфиги вообще не изменились. Так что это у тебя от какой-то не той версии конфиги остались.
Comment 8 a.lahin 2015-06-04 10:06:27 MSD
(In reply to comment #6)
> > В конце концов, тут же не предлагают что-то сделать или выбрать между
> > непонятными действияи. Просто информаци к сведению.
> В том-то и дело что предлагают. Если тама на кнопку нажать, появляется
> диалог выбора. Т.к. файлы сейчас различаются комментариями насколько я
> понял, предлагаю все это убрать.

Можно получить снимок экрана/содержание различий?
Comment 9 Vladimir Potapov 2015-06-04 12:22:58 MSD
Возможно, эти конфиги тянутся еще с R5 - проверил на двух обновленных с r5 систем, диалог присутствует.
Comment 10 Vladimir Potapov 2015-06-04 12:23:23 MSD
Created attachment 4071 [details]
ss2
Comment 11 Vladimir Potapov 2015-06-04 12:23:47 MSD
Created attachment 4072 [details]
ss3
Comment 12 a.lahin 2015-06-04 12:35:15 MSD
(In reply to comment #9)
> Возможно, эти конфиги тянутся еще с R5 - проверил на двух обновленных с r5
> систем, диалог присутствует.

Это странно, при изменении версии initscripts с initscripts-9.45-8 на initscripts-9.45-10 эти конфиги не менялись.
Они должны были поменяться раньше, при переходе на 8.

Для проверки стоит попробовать переустановку версии initscripts-9.45-8 (urpmi --replacepkgs).
Comment 13 Vladimir Potapov 2015-06-04 12:37:48 MSD
Скорее всего просто в прошлый раз эта проблема не была решена и так же диалоги светились. И теперь будут светиться пока не исправим.
Comment 14 a.lahin 2015-06-04 12:38:58 MSD
(In reply to comment #13)
> Скорее всего просто в прошлый раз эта проблема не была решена и так же
> диалоги светились. И теперь будут светиться пока не исправим.

Тогда это не имеет отношения к текущей ошибке? Проверяем дальше?
Comment 15 Vladimir Potapov 2015-06-04 12:41:15 MSD
В остальном все нормально. Потому предлагаю (раз конфиги теперь фейковые и это ни на что не может повлиять) пересобрать с убранным config.
Comment 16 a.lahin 2015-06-04 12:43:46 MSD
(In reply to comment #15)
> В остальном все нормально. Потому предлагаю (раз конфиги теперь фейковые и
> это ни на что не может повлиять) пересобрать с убранным config.

Предлагаю принять изменённые конфиги и больше этого сообщения при обновлении initscripts не будет.
Comment 17 Denis Silakov 2015-06-04 12:52:05 MSD
У inittab действительно можно просто убрать "%config(noreplace)" нафиг в спеке.

А sysctl.conf разве фейковый теперь? В смысле, если кто-то туда что-то свое дописывал, оно больше не будет работать?
Comment 18 Vladimir Potapov 2015-06-04 12:55:02 MSD
Так по-умолчанию то они не принимаются и остаются старыми, насколько я понимаю.
И при следующем обновлении опять. Зачем? Там просто говорится что файлы теперь не нужны. Для обычного пользователя, который в графике обновляется, эта информация сильно излишняя. 

P.S. По регламенту при обновлении проверяется не только декларированное обновление, но и выявляются еще ошибки. Если они могут быть быстро исправлены - правится на месте, если нет - делается отдельный баг. Обновление должно проходить гладко, без запросов, за исключением случаев, когда пользователь что-то правил в конфигах сам - тогда предлагается сохранить его исправление. Здесь же другой случай совсем.
Comment 19 Vladimir Potapov 2015-06-04 12:56:11 MSD
(In reply to comment #17)
> У inittab действительно можно просто убрать "%config(noreplace)" нафиг в
> спеке.
> 
> А sysctl.conf разве фейковый теперь? В смысле, если кто-то туда что-то свое
> дописывал, оно больше не будет работать?

(In reply to comment #17)
> У inittab действительно можно просто убрать "%config(noreplace)" нафиг в
> спеке.
> 
> А sysctl.conf разве фейковый теперь? В смысле, если кто-то туда что-то свое
> дописывал, оно больше не будет работать?

см картинку
http://bugs.rosalinux.ru/attachment.cgi?id=4072

вроде теперь так
Comment 20 Vladimir Potapov 2015-06-04 12:58:50 MSD
(In reply to comment #19)

> А sysctl.conf разве фейковый теперь? В смысле, если кто-то туда что-то свое
> дописывал, оно больше не будет работать?
Вот, кстати, может быть причина бага http://bugs.rosalinux.ru/show_bug.cgi?id=5654
когда с R5 обновляешься и по-умолчанию жмешь, оставались старые конфиги а когда новый образ ставишь - они новые. Нужно бы сравнить и сделать "как в r5" но на новом месте
Comment 21 a.lahin 2015-06-04 13:00:06 MSD
(In reply to comment #18)
> P.S. По регламенту при обновлении проверяется не только декларированное
> обновление, но и выявляются еще ошибки. Если они могут быть быстро
> исправлены - правится на месте, если нет - делается отдельный баг.

В данном случае лучше сделать отдельный баг, по-моему.
Comment 22 Denis Silakov 2015-06-04 13:01:23 MSD
(In reply to comment #19)

> > А sysctl.conf разве фейковый теперь? В смысле, если кто-то туда что-то свое
> > дописывал, оно больше не будет работать?
> 
> см картинку
> http://bugs.rosalinux.ru/attachment.cgi?id=4072
> 
> вроде теперь так

нет, теперь он просто пустой по умолчанию. А изменения из него по-прежнему будут работать. Поэтому сносить его без вопросов совсем нехорошо.

Так что здесь не "другой случай совсем", а как раз тот случай, когда мы имеем шанс удалить все пользовательские изменения.
Comment 23 Vladimir Potapov 2015-06-04 13:06:32 MSD
(In reply to comment #22)
> 
> нет, теперь он просто пустой по умолчанию. А изменения из него по-прежнему
> будут работать. Поэтому сносить его без вопросов совсем нехорошо.
> 
> Так что здесь не "другой случай совсем", а как раз тот случай, когда мы
> имеем шанс удалить все пользовательские изменения.
А можно его сравнить с нашим предыдущим по-умолчанию и только если есть различия запрос выводить?
Comment 24 Vladimir Potapov 2015-06-04 13:07:27 MSD
(In reply to comment #21)
> (In reply to comment #18)
> > P.S. По регламенту при обновлении проверяется не только декларированное
> > обновление, но и выявляются еще ошибки. Если они могут быть быстро
> > исправлены - правится на месте, если нет - делается отдельный баг.
> 
> В данном случае лучше сделать отдельный баг, по-моему.
Пара подряд изменений initscript на пользователей? Не очень такого хочется.
Comment 25 a.lahin 2015-06-04 13:11:46 MSD
(In reply to comment #24)
> > В данном случае лучше сделать отдельный баг, по-моему.
> Пара подряд изменений initscript на пользователей? Не очень такого хочется.

Я могу не спешить со вторым (сделаем его через месяц, например), так что пользователи не пострадают.
Comment 26 Denis Silakov 2015-06-04 13:15:36 MSD
(In reply to comment #23)
> (In reply to comment #22)
> > 
> > нет, теперь он просто пустой по умолчанию. А изменения из него по-прежнему
> > будут работать. Поэтому сносить его без вопросов совсем нехорошо.
> > 
> > Так что здесь не "другой случай совсем", а как раз тот случай, когда мы
> > имеем шанс удалить все пользовательские изменения.
> А можно его сравнить с нашим предыдущим по-умолчанию и только если есть
> различия запрос выводить?

rpm такого не умеет. Это придется какие-то свистопляски придумывать, необходимость которых сомнительна.

Вообще у нас же куча таких конфигов в дистрибутиве, про которые пользователей что-то спрашивают уже много лет. Чем вдруг именно эти не понравились? Тогда уж надо более глобальную задачу ставить - типа придумать какой-то более умный механизм их обновления. Иначе мы так с каждым пакетом, содержащим конфиг-файлы, по полдня разбираться будем.
Comment 27 Vladimir Potapov 2015-06-04 13:24:13 MSD
(In reply to comment #26)
> Вообще у нас же куча таких конфигов в дистрибутиве, про которые
> пользователей что-то спрашивают уже много лет. Чем вдруг именно эти не
> понравились? Тогда уж надо более глобальную задачу ставить - типа придумать
> какой-то более умный механизм их обновления. Иначе мы так с каждым пакетом,
> содержащим конфиг-файлы, по полдня разбираться будем.
В том-то и дело что не куча. Обычно я такие вопросы ловлю и давлю чтоб граф обновление проходило гладко, вообще без вопросов пользователю. В r5 так вот не удается из-за глобальности обновлений. 
Ок, если красиво решить нельзя, то пусть хоть фейковый обновляется без вопросов...

Но настройки по багу Нико я бы посмотрел подробнее.
Comment 28 Vladimir Potapov 2015-06-04 19:34:00 MSD
The update is sent to expanded testing
***************************************
Comment 29 Vladimir Potapov 2015-06-09 14:40:40 MSD
initscripts-9.45-10
https://abf.io/build_lists/2506510
https://abf.io/build_lists/2506511
********************************* Advisory ****************************
Fix empty locale environment
***********************************************************************
QA Verified